unit UTRIXI;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Button4: TButton;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label4: TLabel;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;


function Connect(Server: PAnsiChar; Port: Integer): Boolean; stdcall external 'TRIXI.DLL';
function Disconnect(): Boolean; stdcall external 'TRIXI.DLL';
function IsOnline(): Boolean; stdcall external 'TRIXI.DLL';
function WriteString(Variable: Integer; Value: PAnsiChar): Integer; stdcall external 'TRIXI.DLL';
function WriteInteger(Variable: Integer; Value: Integer): Integer; stdcall external 'TRIXI.DLL';
function WriteFloat(Variable: Integer; Value: Double): Integer; stdcall external 'TRIXI.DLL';
function WriteBoolean(Variable: Integer; Value: Boolean): Integer; stdcall external 'TRIXI.DLL';
function ReadString(Variable: Integer): PAnsiChar; stdcall external 'TRIXI.DLL';
function ReadInteger(Variable: Integer): Integer; stdcall external 'TRIXI.DLL';
function ReadFloat(Variable: Integer): Double; stdcall external 'TRIXI.DLL';
function ReadBoolean(Variable: Integer): Boolean; stdcall external 'TRIXI.DLL';
function RunScript(Variable: Integer): Integer; stdcall external 'TRIXI.DLL';

// --- Professional implementation -------------------------------------------
type
  TSimpleVarCallback = procedure(ID: Integer);
  TVarCallback = procedure(ID: Integer; Time: Double; Value: PAnsiChar);

procedure SetSimpleVarCallback(Value: TSimpleVarCallback); stdcall external 'TRIXI.DLL';
procedure SetVarUpdateCallback(Value: TVarCallback); stdcall external 'TRIXI.DLL';
procedure SetVarChangeCallback(Value: TVarCallback); stdcall external 'TRIXI.DLL';
function GetScriptIDByName(Script: PAnsiChar; ParentID: Integer): Integer; stdcall external 'TRIXI.DLL';
function GetVariableIDByName(Variable: PAnsiChar; ParentID: Integer): Integer; stdcall external 'TRIXI.DLL';
function VariableExists(VariableID: Integer): Boolean; stdcall external 'TRIXI.DLL';
function ScriptExists(ScriptID: Integer): Boolean; stdcall external 'TRIXI.DLL';
procedure WriteDebugFile(FilePath: PAnsiChar; MsgSink: Boolean); stdcall external 'TRIXI.DLL';


implementation

{$R *.dfm}

procedure callback(ID: Integer; Time: Double; Value: PAnsiChar);
begin
  showmessage(IntToStr(ID)+'#'+DateTimeToStr(Time)+'#'+Value);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  WriteDebugFile(PAnsiChar('TRIXI.log'), true);
end;

procedure TForm1.Button1Click(Sender: TObject);
var Server: AnsiString;
begin
  Server:=AnsiString(Edit1.Text);
  if Connect(PAnsiChar(Server), 3773) then
  begin
    SetVarUpdateCallback(callback);
    SetVarChangeCallback(callback);
    showmessage('Online');
  end
  else
  begin
    showmessage('Fail');
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if IsOnline then
    Label1.Caption:='Online'
  else
    Label1.Caption:='Offline';
end;

procedure TForm1.Button3Click(Sender: TObject);
var ID: Integer;
    Str: AnsiString;
begin
  ID:=StrToInt(Edit2.Text);
  Str:=AnsiString(Edit3.Text);
  WriteString(ID, PAnsiChar(Str));
end;

procedure TForm1.Button4Click(Sender: TObject);
var ID: Integer;
    Str: AnsiString;
begin
  ID:=StrToInt(Edit2.Text);
  Str:=ReadString(ID);
  showmessage(WideString(Str));
end;

procedure TForm1.Button5Click(Sender: TObject);
var ID: Integer;
begin
  if VariableExists(12345) then
    showmessage('Variable existiert im System')
  else
    showmessage('ID ist dem System nicht bekannt');    
    
  showmessage(IntToStr(GetVariableIDByName(PAnsiChar('TestString'), 23607)));
  showmessage(IntToStr(GetScriptIDByName(PAnsiChar('TestScript'), 0)));
end;

end.
